#include "common.h"
#include <tr1/unordered_map>
#include "tbb/spin_mutex.h"

using namespace std::tr1;

// Shared STL hash table that maps strings to ints
unordered_map<std::string, int> CoarseGrainStringTable;

// FIXME - declare a tbb::spin_mutex here to protect the shared table.

void CoarseGrainClear() {
    CoarseGrainStringTable.clear();
}

void CoarseGrainUpdate( const std::string& key ) {
    // FIXME - acquire a lock on the mutex that you added above
    // Be sure that the lock is released after the update.

    // Update the map 
    CoarseGrainStringTable[key] += 1;
}

int CoarseGrainGet( const std::string& key ) {
    unordered_map<std::string,int>::iterator k = CoarseGrainStringTable.find(key);
    return k!=CoarseGrainStringTable.end() ? k->second : 0;
}
