#include <string>

// The routines below are organized into groups of three.
// Each group controls an implementation of a hash table
// that maps keys to counts.
//     ...Clear() clears the table.
//     ...Update(k) updates the count for key k.
//     ...Get(k) returns the count for k.
// Only the Update operation is thread-safe.

void SerialClear();
void SerialUpdate( const std::string& key );
int SerialGet( const std::string& key );

void CoarseGrainClear();
void CoarseGrainUpdate( const std::string& key );
int CoarseGrainGet( const std::string& key );

void FineGrainClear();
void FineGrainUpdate( const std::string& key );
int FineGrainGet( const std::string& key );
