#include "common.h"
#include <tr1/unordered_map>

using namespace std::tr1;

// STL map that maps strings to ints
unordered_map<std::string, int> SerialStringTable;

void SerialClear() {
    SerialStringTable.clear();
}

void SerialUpdate( const std::string& key ) {
    // Update the map 
    SerialStringTable[key] += 1;
}

int SerialGet( const std::string& key ) {
    unordered_map<std::string,int>::iterator k = SerialStringTable.find(key);
    return k!=SerialStringTable.end() ? k->second : 0;
}
