#include "common.h"
#include "tbb/concurrent_hash_map.h"

// concurrent hash table that maps strings to ints
tbb::concurrent_hash_map<std::string, int> FineGrainStringTable;

void FineGrainClear() {
    FineGrainStringTable.clear();
}

void FineGrainUpdate( const std::string& key ) {
    tbb::concurrent_hash_map<std::string, int>::accessor a;
    FineGrainStringTable.insert(a,key);
    a->second += 1;
}

int FineGrainGet( const std::string& key ) {
    tbb::concurrent_hash_map<std::string, int>::const_accessor a;
    if( FineGrainStringTable.find(a,key) )
        return a->second;
    else
        return 0;
}
