#include <cstdio>
using namespace std;

// Evaluate expression f(i) for each i in the half-open interval [lower,upper)
template<typename Functor>
void ForEach( int lower, int upper, const Functor& f ) {
    for( int i=lower; i<upper; ++i )
        f(i);
}

// Compute factorial of 4 
int LambdaFactorial() {
    int x=1;
    ForEach( 1, 
             5, 
             [&](int i) {
                 x*=i;
             });
    return x;
}

// Functor corresponding to result of the lambda expression in LambdaFactorial().
class MyFunctor {
    // FIXME: See constructor below that takes parmaeter x_.  
    // Add a field here to hold a reference to x_. 
    // If you are more comfortable with C, make the field have type int* instead of int&.
public:

    // Constructor for the functor that corresponds to the lambda expression
    MyFunctor(int& x_) 
        // FIXME: add code to save a reference to x_ in the field that you added.
    {
        // FIXME: If you are more comfortable with C, using pointer assignment here 
        // to save the address of x.
    }

    // Member that defines calling the functor.
    void operator()(int i) const {
        // FIXME: add code to evaluate x*=i, but using the reference/address that you
        // saved in the field that you added.
    }
};
 
// Compute factorial of 4 
int ManualFactorial() {
    int x=1;
    ForEach( 1, 
             5, 
             MyFunctor(x) );
    return x;
}

int main() {
    printf("LambdaFactorial returns %d\n", LambdaFactorial());
    printf("ManualFactorial returns %d\n", ManualFactorial());
    return 0;
}
