#include "common.h"
#include "tbb/blocked_range.h"
#include "tbb/parallel_for.h"

using namespace tbb;

// Set c = matrix product of a and b
void ParallelMatrixMultiply (float c[N][N], const float a[N][N], const float b[N][N]) {
    // Parallelize over the "i" iteration space of the serial code.
    parallel_for( 
        // 1st argument is the iteration space.  
        ...FIXME - use a blocked_range here...

        // 2nd argument is the loop body
        [&]( blocked_range<size_t> r ) {
            // r is a subrange of the "i" iteraiton space.
            ...FIXME - fill in body of the lambda...  
#if 0 /* Original serial code */
    for (size_t i = 0; i < N; ++i ) {
        for (size_t j = 0; j < N; ++j ) {
            float sum = 0;
            for (size_t k = 0; k < N; ++k )
                sum += a[i][k]*b[k][j];
            c[i][j] = sum;
        }
    }
#endif
        },

        // In Intel(R) TBB 2.2, 3rd argument defaults to auto_partitioner.  
        // Since we are using Intel(R) TBB 2.1, we have to be explicit.
        auto_partitioner()
    );
}

