#include "common.h"
#include "tbb/blocked_range.h"
#include "tbb/parallel_for.h"

using namespace tbb;

// Set c = matrix product of a and b
void ParallelMatrixMultiply (float c[N][N], const float a[N][N], const float b[N][N]) {
    parallel_for( 
        blocked_range<size_t>(0,N), 
        [&]( blocked_range<size_t> r ) {
            for( size_t i = r.begin(); i<r.end(); ++i ) {
                for( int j=0; j<N; ++j ) {
                    float sum = 0;
                    for( int k=0; k<N; ++k ) 
                        sum += a[i][k]*b[k][j];
                    c[i][j] = sum;
                }
            }
        },
        auto_partitioner()
    );
}

