#include "common.h"

void SerialKaratsubaMul( Digit z[], const Digit x[], const Digit y[], size_t n ) {
    if( n<=CutOff ) {
        SimpleMul( z, x, y, n );
    } else {
        size_t m = n/2;
        SerialKaratsubaMul( z, x, y, m );
        SerialKaratsubaMul( z+n, x+m, y+m, m );
        TempSpace s(3*n);
        Digit* a = s+0;
        Digit* b = s+n;
        Digit* c = s+2*n;
        Add( a, x, x+m, m );
        Add( b, y, y+m, m ); 
        SerialKaratsubaMul( c, a, b, m ); 
        AssignSubSub( c, z, z+n, n );
        Add( z+m, z+m, c, n ); 
    }
}

